package com.sun.java.swing.plaf.windows;

import javax.swing.BoundedRangeModel;
import java.awt.Insets;
import javax.swing.plaf.TextUI;
import javax.swing.text.BadLocationException;
import javax.swing.text.Position;
import javax.swing.JTextField;
import javax.swing.text.JTextComponent;
import javax.swing.text.Highlighter;
import javax.swing.SwingUtilities;
import java.awt.Rectangle;
import javax.swing.plaf.UIResource;
import javax.swing.text.DefaultCaret;
import javax.swing.text.Caret;
import java.awt.Graphics;
import javax.swing.plaf.ComponentUI;
import javax.swing.JComponent;
import javax.swing.plaf.basic.BasicTextFieldUI;

public class WindowsTextFieldUI extends BasicTextFieldUI
{
    public WindowsTextFieldUI() {
    }
    
    public static ComponentUI createUI(JComponent component) {
        return new WindowsTextFieldUI();
    }
    
    @Override
    protected void paintBackground(Graphics g) {
        super.paintBackground(g);
    }
    
    @Override
    protected Caret createCaret() {
        return new WindowsTextFieldUI.WindowsFieldCaret();
    }
    
    static class WindowsFieldCaret extends DefaultCaret implements UIResource
    {
        public WindowsFieldCaret() {
        }
        
        @Override
        protected void adjustVisibility(Rectangle rectangle) {
            SwingUtilities.invokeLater(new WindowsTextFieldUI.WindowsFieldCaret.SafeScroller(rectangle));
        }
        
        @Override
        protected Highlighter.HighlightPainter getSelectionPainter() {
            return WindowsTextUI.WindowsPainter;
        }
        
        static JTextComponent access$000(WindowsTextFieldUI.WindowsFieldCaret windowsFieldCaret) {
            return windowsFieldCaret.getComponent();
        }
        
        static void access$100(WindowsTextFieldUI.WindowsFieldCaret windowsFieldCaret, Rectangle r) {
            windowsFieldCaret.damage(r);
        }
        
        private class SafeScroller implements Runnable
        {
            private Rectangle r;
            
            SafeScroller(Rectangle r) {
                this.r = r;
            }
            
            @Override
            public void run() {
                JTextField textField = (JTextField)WindowsTextFieldUI.WindowsFieldCaret.access$000(WindowsTextFieldUI.WindowsFieldCaret.this);
                if (textField != null) {
                    TextUI ui = textField.getUI();
                    int dot = WindowsTextFieldUI.WindowsFieldCaret.this.getDot();
                    Position.Bias forward = Position.Bias.Forward;
                    Rectangle modelToView = null;
                    try {
                        modelToView = ui.modelToView(textField, dot, forward);
                    }
                    catch (BadLocationException ex) {}
                    Insets insets = textField.getInsets();
                    BoundedRangeModel horizontalVisibility = textField.getHorizontalVisibility();
                    int n = this.r.x + horizontalVisibility.getValue() - insets.left;
                    int n2 = horizontalVisibility.getExtent() / 4;
                    if (this.r.x < insets.left) {
                        horizontalVisibility.setValue(n - n2);
                    }
                    else if (this.r.x + this.r.width > insets.left + horizontalVisibility.getExtent()) {
                        horizontalVisibility.setValue(n - 3 * n2);
                    }
                    if (modelToView != null) {
                        try {
                            Rectangle modelToView2 = ui.modelToView(textField, dot, forward);
                            if (modelToView2 != null && !modelToView2.equals(modelToView)) {
                                WindowsTextFieldUI.WindowsFieldCaret.access$100(WindowsTextFieldUI.WindowsFieldCaret.this, modelToView2);
                            }
                        }
                        catch (BadLocationException ex2) {}
                    }
                }
            }
        }
    }
}
